import mysql.simplesql as sql

tables = ['changeAccountBalance']
changeTypes = {"PUT": 0, "ADD": 1, "SUB": 2, "SET_BALANCE": 3, "SET_BALANCE_FORCE": 4}


def compileChangeType(changeType):
    return changeTypes.get(changeType, -1)


def insertChangeAccountBalance(changeAccountBalance):
    yield sql.Insert(table='changeAccountBalance', values={
        'sessionId': changeAccountBalance.get('sessionid', None),
        'accountNumber': changeAccountBalance.get('accountnumber', None),
        'cardNumber': changeAccountBalance.get('cardnumber', None),
        'changeType': compileChangeType(changeAccountBalance.get('changetype', None)),
        'value': changeAccountBalance.get('value', None),
        'groupId': changeAccountBalance.get('groupid', None),
        'begin': changeAccountBalance.get('begin', None),
        'end': changeAccountBalance.get('end', None),
        'weight': changeAccountBalance.get('weight', None),
        'serverId': changeAccountBalance.get('serverid', None),
        'source': changeAccountBalance.get('source', None),
        'reason': changeAccountBalance.get('reason', None)
    })


def clearChangeAccountBalance():
    yield sql.DeleteAll(table='changeAccountBalance')


def deleteChangeAccountBalance(changeAccountBalance):
    yield sql.Delete(table='changeAccountBalance', whereFields=['sessionId'],
            whereValues=[changeAccountBalance.get('sessionid', None)])


def deleteChangeAccountBalanceById(sessionId):
    yield sql.Delete(table='changeAccountBalance', whereFields=['sessionId'], whereValues=[sessionId])
