import mysql.simplesql as sql

tables = ['cmaction', 'actionparameter']


def insertCmaction(cmaction):
    yield sql.Insert(table='cmaction', values={
        'cmactioncode': cmaction.get('cmactioncode', 0),
        'cmactionname': cmaction.get('cmactionname', None),
        'commandcode': cmaction.get('commandcode', None),
        'notshowinservicemenu': cmaction.get('notshowinservicemenu', None),
    })
    yield sql.Delete(table='actionparameter',
        whereFields=['cmactioncode'],
        whereValues=[cmaction.get('cmactioncode', '')])

    if cmaction.get('actionparameters',None):
        for r in cmaction.get('actionparameters',):
            yield sql.Insert(table='actionparameter', values={
                'parameterorder': r.get('parameterorder', None),
                'parametervalue': r.get('parametervalue', None),
                'cmactioncode': cmaction.get('cmactioncode', None),
                'parametername': r.get('parametername', None),
            })


def deleteCmaction(cmaction):
    yield sql.Delete(table='cmaction', whereFields=['cmactioncode'], whereValues=[cmaction.get('cmactioncode', 0)])
    yield sql.Delete(table='actionparameter', whereFields=['cmactioncode'],
            whereValues=[cmaction.get('cmactioncode', '')])


def clearCmaction():
    yield sql.DeleteAll(table='cmaction')
    yield sql.DeleteAll(table='actionparameter')


def deleteCmactionByCode(code):
    yield sql.Delete(table='cmaction', whereFields=['cmactioncode'], whereValues=[code])
    yield sql.Delete(table='actionparameter', whereFields=['cmactioncode'], whereValues=[code])
